Ext.onReady(function(){
    Ext.QuickTips.init();
    
    var storeEmpresaCombo = new Ext.data.JsonStore({
            storeId:'store-empresa-combo-login',
            proxy:new Ext.data.HttpProxy({url:'clases/controladores/ControladorApp.php'}),
            remoteSort : true,
            restful : true,
            autoLoad:true,
            baseParams: {                
                accion: 'Accion/Empresa/Get_Empresas_Combo',
                output: 'json'
            },
            fields: [
                        {name:'cod_empresa', type:'int'},
            {name:'nombre', type:'string'},
            {name:'bd', type:'string'},
            {name:'bd_contabilidad', type:'string'},
            {name:'bd_nomina', type:'string'}
                    ],
            listeners: {
                load: function(Store ,records, options){ 
                    //console.log(Store);
                }
            }
    });
    
    var comboEmpresa = new Ext.form.ComboBox({
    xtype:          'combo',
    anchor:'96%',
    mode:           'local',
    triggerAction:  'all',
    fieldLabel:     ENTERPRISE,
    name:           'cod_empresa',
    hiddenName:     'cod_empresa',
    id:     'enterprise_id_combo-login',
    displayField:   'nombre',
    valueField : 'cod_empresa',
    emptyText:ENTERPRISE_COMBO_EMPTY_TEXT,
        allowBlank:true,
    editable:false,
    store: storeEmpresaCombo,
        listeners:{
            beforeselect:function(combo,record,index){
            },
            select:function(cmb,rec,idx){
                
            }
    }                                
    });
    function envioLogin(){
    	login.getForm().submit({ 
            method:'POST', 
            waitTitle:SEND_LOGIN_TITLE, 
            waitMsg:SEND_LOGIN,
            submitEmptyText: false,
            params:{
                operacion: 'login',//select
                accion: 'Accion/Session/Login',
                output: 'json'	
            },
            success:function(form, action){
            	if(action.result.login == false)
            		Ext.MessageBox.alert('Error',action.result.mensaje);
            	else{
                        Ext.example.msg('Login', action.result.mensaje);
                        DASHBOARD_FILE = action.result.user.dashboard_file;
                        ID_CONSULTAS_WEB = action.result.user.usuario_id;
     					  DASHBOARD_ID = action.result.user.dashboard_id;
                                          DEPTO_ID = action.result.user.depto_id;
                                          TIPO_USUARIO_ID = action.result.user.tipo_usr_id;
                        USUARIO_SESSION = action.result.user.login;
                        USUARIO_EMPRESA = action.result.user.cod_empresa;
     					  ScriptMgr.load({
	    					  scripts: ["init/diccionario_fields.js","libs/ext-3.4.0/ux/ColumnHeaderGroup.js","libs/ext-3.4.0/ux/CheckColumn.js","libs/ext-3.4.0/ux/GroupSummary.js","libs/ext-3.4.0/ux/RowExpander.js","libs/ext-3.4.0/ux/Spinner.js","libs/ext-3.4.0/ux/SpinnerField.js","libs/ext-3.4.0/ux/fileuploadfield/FileUploadField.js","libs/ext-3.4.0/ux/RowEditor.js",DASHBOARD_FILE,"home.js"],// recepcionForm
	    					  callback: function() {							
     						  	loginwin.hide();
	    					  }
	    					}); 
            		/*Ext.Msg.alert('Login', action.result.mensaje, function(btn, text){
     				   if (btn == 'ok'){
     					   
     					  DASHBOARD_FILE = action.result.user.dashboard_file;
     					  DASHBOARD_ID = action.result.user.dashboard_id;
     					  ScriptMgr.load({
	    					  scripts: ["init/diccionario_fields.js","libs/ext-3.4.0/ux/ColumnHeaderGroup.js","libs/ext-3.4.0/ux/CheckColumn.js","libs/ext-3.4.0/ux/GroupSummary.js",DASHBOARD_FILE,"home.js"],// recepcionForm
	    					  callback: function() {							
     						  	loginwin.hide();
	    					  }
	    					}); 
     				   }
     			    });*/
            	}
            	
            },
            failure:function(form, action){ 
                if(action.failureType == 'server'){ 
                    obj = Ext.util.JSON.decode(action.response.responseText); 
                    Ext.Msg.alert('Login Failed!', obj.errors.reason); 
                }else{ 
                    Ext.Msg.alert('Warning!', 'Authentication server is unreachable : ' + action.response.responseText); 
                } 
                login.getForm().reset(); 
            } 
        });
    }
    
	// Create a variable to hold our EXT Form Panel. 
	// Assign various config options as seen.	 
    var login = new Ext.FormPanel({ 
        labelWidth:80,
        url:'clases/controladores/ControladorApp.php', 
        frame:true, 
        title:'Login', 
        defaultType:'textfield',
        monitorValid:true,
		// Specific attributes for the text fields for username / password. 
		// The "name" attribute defines the name of variables sent to the server.
        items:[{ 
                fieldLabel:USER, 
                name:'login', 
                allowBlank:false,
                listeners:{
                    blur:function(cmb){
                        var cmbEmp = Ext.getCmp("enterprise_id_combo-login");
                        if(this.getValue() == "admin" || this.getValue() == "asys"){
                            cmbEmp.allowBlank = true;
                        }
                        else{
                            cmbEmp.allowBlank = false;
                        }
                        
                    }
                } 
            },{ 
                fieldLabel:PASSWORD, 
                name:'password', 
                inputType:'password', 
                allowBlank:false ,            		
                listeners:{
		        	specialkey: function(patronBlbuscar,e){ 
		            	if (e.getKey() == e.ENTER) { 
		            		envioLogin(); 
		            	}
	    			}
	  			}
            },
            comboEmpresa
            ],
 
	
        buttons:[{ 
                text:LOGIN_BUTTON,
                formBind: true,	 
                // Function that fires when user clicks the button 
                handler:envioLogin
            }] 
    });
 
 
	// This just creates a window to wrap the login form. 
	// The login object is passed to the items collection.       
    var loginwin = new Ext.Window({
    	id:'login-win',
        draggable: false,
        layout:'fit',
        width:300,
        height:170,
        closable: false,
        resizable: false,
        plain: true,
        border: false,
        items: [login]
	});
    loginwin.show();
});